#!/bin/sh

# TODO test ALL engines: attribute-aware, averages, etc.

PROGRAM="mono --debug RatingPrediction.exe"
DATA_DIR=../../../../data/ml100k

cd src/RatingPrediction/bin/Debug/

echo "This will take about 5 minutes ..."

echo
echo "rating prediction engines"
echo "-------------------------"

# load/save currently not supported: global-average user-average item-average

for method in UserItemBaseline SlopeOne BipolarSlopeOne MatrixFactorization BiasedMatrixFactorization
do
     echo $PROGRAM u1.base u1.test $method save_model=tmp.model data_dir=$DATA_DIR
          $PROGRAM u1.base u1.test $method save_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output1.txt
     echo $PROGRAM u1.base u1.test $method load_model=tmp.model data_dir=$DATA_DIR
          $PROGRAM u1.base u1.test $method load_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output2.txt
     diff output1.txt output2.txt
done

for method in UserKNNCosine ItemKNNCosine
do
     echo $PROGRAM u1.base u1.test $method k=20 save_model=tmp.model data_dir=$DATA_DIR
	  $PROGRAM u1.base u1.test $method k=20 save_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output1.txt
     echo $PROGRAM u1.base u1.test $method k=20 load_model=tmp.model data_dir=$DATA_DIR
	  $PROGRAM u1.base u1.test $method k=20 load_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output2.txt
     diff output1.txt output2.txt
done

for method in UserKNNPearson ItemKNNPearson
do
     echo $PROGRAM u1.base u1.test $method k=20 shrinkage=10 save_model=tmp.model data_dir=$DATA_DIR
	  $PROGRAM u1.base u1.test $method k=20 shrinkage=10 save_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output1.txt
     echo $PROGRAM u1.base u1.test $method k=20 shrinkage=10 load_model=tmp.model data_dir=$DATA_DIR
	  $PROGRAM u1.base u1.test $method k=20 shrinkage=10 load_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output2.txt
     diff output1.txt output2.txt
done

rm tmp.model output1.txt output2.txt

echo
echo "item prediction engines"
echo "-----------------------"

PROGRAM="mono --debug ItemPrediction.exe"

cd ../../../ItemPrediction/bin/Debug/

for method in WRMF BPRMF MostPopular
do
     echo $PROGRAM u1.base u1.test $method save_model=tmp.model data_dir=$DATA_DIR
          $PROGRAM u1.base u1.test $method save_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output1.txt
     echo $PROGRAM u1.base u1.test $method load_model=tmp.model data_dir=$DATA_DIR
          $PROGRAM u1.base u1.test $method load_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output2.txt
     diff output1.txt output2.txt
done

for method in UserKNN ItemKNN WeightedUserKNN WeightedItemKNN
do
     echo $PROGRAM u1.base u1.test $method k=20 save_model=tmp.model data_dir=$DATA_DIR
	  $PROGRAM u1.base u1.test $method k=20 save_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output1.txt
     echo $PROGRAM u1.base u1.test $method k=20 load_model=tmp.model data_dir=$DATA_DIR
	  $PROGRAM u1.base u1.test $method k=20 load_model=tmp.model data_dir=$DATA_DIR | perl -pe "s/\w+ing_time \S+ ?//g" > output2.txt
     diff output1.txt output2.txt
done

for method in BPR_Linear ItemAttributeKNN
do
     echo $PROGRAM u1.base u1.test $method k=20 save_model=tmp.model data_dir=$DATA_DIR item_attributes=item-attributes-genres.txt
	  $PROGRAM u1.base u1.test $method k=20 save_model=tmp.model data_dir=$DATA_DIR item_attributes=item-attributes-genres.txt | perl -pe "s/\w+ing_time \S+ ?//g" > output1.txt
     echo $PROGRAM u1.base u1.test $method k=20 load_model=tmp.model data_dir=$DATA_DIR item_attributes=item-attributes-genres.txt
	  $PROGRAM u1.base u1.test $method k=20 load_model=tmp.model data_dir=$DATA_DIR item_attributes=item-attributes-genres.txt | perl -pe "s/\w+ing_time \S+ ?//g" > output2.txt
     diff output1.txt output2.txt
done

rm tmp.model output1.txt output2.txt

cd ../../../../
